Subject: Re: bug#79346: igc: PolicyShouldCollectWorld

From: Helmut Eller <[email-masked]>
Date: Sun, 31 Aug 2025 09:32:24 +0200

On Sat, Aug 30 2025, Eli Zaretskii wrote:

>> It seems that availableTime and collectionTime use different units:
>> availableTime is in clocks while collectionTime is in seconds.
>> 
>> So the test availableTime > collectionTime doesn't make much sense.
>
> Since I don't see such comparison anywhere in Emacs, I presume you are
> talking about a bug in MPS?  Or what did I miss?

Yes, the comparison is in PolicyShouldCollectWorld.  The call chain is
usually: timer_check_2 -> igc_on_idle -> mps_arena_step -> ArenaStep ->
PolicyShouldCollectWorld.

It looks like the bug is in ArenaStep: it should divide the by
clocks_per_second before calling PolicyShouldCollectWorld.

Helmut